import { isJSON } from './utils/json'
const expireLocalStorage = {
  setItem: (key, value, option = {}) => {
    const item = {
      value,
      type: 'expireLocalStroage',
    }
    if (option.expires) {
      item.expire = new Date(new Date() * 1 + option.expires * 864e5)
    }
    localStorage.setItem(key, JSON.stringify(item))
  },
  getItem: (key) => {
    const itemStr = localStorage.getItem(key)
    if (!itemStr) {
      return null
    }
    let isJson = isJSON(itemStr)
    if (isJson) {
      const item = JSON.parse(itemStr)
      let now = new Date()
      if (now.getTime() > item.expires) {
        localStorage.removeItem(key)
        return null
      }
      return item.value
    }
    return null
  },
  _getItem: (key) => {
    const itemStr = localStorage.getItem(key)
    if (!itemStr) {
      return null
    }
    let isJson = isJSON(itemStr)
    if (isJson) {
      const item = JSON.parse(itemStr)
      let now = new Date()
      if (now.getTime() > item.expires) {
        localStorage.removeItem(key)
        return null
      }
      return item
    }
    return null
  },
  removevItem: (key) => {
    localStorage.removeItem(key)
  },
  key: (n) => {
    let keys = expireLocalStorage.keys()
    let name = ''
    keys.map((key, i) => {
      if (i === n) {
        name = key
      }
    })
    return name
  },
  keys: () => {
    let keys = []
    for (let key in localStorage) {
      let value = localStorage.getItem(key)
      let isJson = isJSON(value)
      if (isJson) {
        value = JSON.parse(value)
        if (value && value.type && value.type === 'expireLocalStroage') {
          keys.push(key)
        }
      }
    }
    return keys
  },
  values: () => {
    let values = []
    for (let key in localStorage) {
      let value = localStorage.getItem(key)
      let isJson = isJSON(value)
      if (isJson) {
        value = JSON.parse(value)
        if (value && value.type && value.type === 'expireLocalStroage') {
          values.push(value.value)
        }
      }
    }
    return values
  },
  entires: () => {
    let entires = []
    for (let key in localStorage) {
      let value = localStorage.getItem(key)
      let isJson = isJSON(value)
      if (isJson) {
        value = JSON.parse(value)
        if (value && value.type && value.type === 'expireLocalStroage') {
          entires.push([key, value.value])
        }
      }
    }
    return entires
  },
  clear: () => {
    let list = expireLocalStorage.keys()
    list.map((key) => {
      localStorage.removeItem(key)
    })
  },
}
// 浏览器页面关闭
window.onbeforeunload = function (e) {
  let keys = expireLocalStorage.keys()
  if (keys && Array.isArray(keys)) {
    keys.map((key) => {
      let value = expireLocalStorage.getItem(key)
      if (value && value.type === 'expireLocalStroage') {
        if (!value.expire) {
          expireLocalStorage.removevItem(key)
        }
      }
    })
  }
}

export default expireLocalStorage
